<?php
/**
 * @author    JoomlaShine.com http://www.joomlashine.com
 * @copyright Copyright (C) 2008 - 2011 JoomlaShine.com. All rights reserved.
 * @license   GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 */
	// No direct access
	defined( '_JEXEC' ) or die( 'Restricted index access' );

	class JSNUtils {

		function JSNUtils() {}
		/**
		 * Return class instance
		 *
		 */
		function &getInstance() {
			static $instance;

			if ($instance == null) {
				$instance = new JSNUtils();
			}

			return $instance;
		}
		/**
		 * Get and store template attributes
		 *
		 */
		function getTemplateAttributes($attrs_array, $template_prefix, $pageclass) {
			$template_attrs = null;
			if(count($attrs_array)) {
				foreach ($attrs_array as $attr_name => $attr_values) {
					$t_attr = null;

					// Get template settings from page class suffix
					if(!empty($pageclass)){
						$pc = 'custom-'.$attr_name.'-';
						$pc_len = strlen($pc);
						$pclasses = explode(" ", $pageclass);
						foreach($pclasses as $pclass){
							if(substr($pclass, 0, $pc_len) == $pc) {
								$t_attr = substr($pclass, $pc_len, strlen($pclass)-$pc_len);
							}
						}
					}
					if( isset( $_GET['jsn_setpreset'] ) && $_GET['jsn_setpreset'] == 'default' ) {
						setcookie($template_prefix.$attr_name, '', time() - 3600, '/');
					} else {
						// Apply template settings from cookies
						if (isset($_COOKIE[$template_prefix.$attr_name])) {
							$t_attr = $_COOKIE[$template_prefix.$attr_name];
						}

						// Apply template settings from permanent request parameters
						if (isset($_GET['jsn_set'.$attr_name])) {
							setcookie($template_prefix.$attr_name, trim($_GET['jsn_set'.$attr_name]), time() + 3600, '/');
							$t_attr = trim($_GET['jsn_set'.$attr_name]);
						}
					}

					// Store template settings
					$template_attrs[$attr_name] = null;
					if(is_array($attr_values)){
						if (in_array($t_attr, $attr_values)) {
							$template_attrs[$attr_name] = $t_attr;
						}
					} else if($attr_values == 'integer'){
						$template_attrs[$attr_name] = intval($t_attr);
					}
				}
			}

			return $template_attrs;
		}
		
		/**
		 * Get template details
		 *
		 */
		function getTemplateDetails()
		{
			require_once 'jsn_readxmlfile.php';
			$jsn_readxml = new JSNReadXMLFile();
			
			return $jsn_readxml->getTemplateInfo();
		}

		/**
		 * Get template parameters
		 *
		 */
		function getTemplateParameters($template_name)
		{
			$params 	= array();
			$path	 	= JPATH_THEMES.DS.$template_name.DS.'params.ini';
			if (is_readable($path))
			{
				$content = file_get_contents($path);
				$params = new JParameter($content);
			}
			return $params;
		}

		/**
		 * Add template attribute to URL, used by Site Tools
		 *
		 */
		function addAttributeToURL($key, $value) {
			$url = $_SERVER['REQUEST_URI'];
			$url = JFilterOutput::ampReplace($url);
			for($i = 0, $count_key = substr_count($url, 'jsn_set'); $i < $count_key; $i ++) {
				$url = preg_replace('/(.*)(\?|&)jsn_set[a-z]{0,30}=[^&]+?(&)(.*)/i', '$1$2$4', $url . '&');
				$url = substr($url, 0, -1);
			}
		    if (strpos($url, '?') === false) {
		        return ($url . '?' . $key . '=' . $value);
		    } else {
		        return ($url . '&amp;' . $key . '=' . $value);
		    }
		}
		/**
		 * Return the number of module positions count
		 *
		 */
		function countPositions($t, $positions) {
			$positionCount = 0;
			for($i=0;$i < count($positions); $i++){
				if ($t->countModules($positions[$i])) $positionCount++;
			}
			return $positionCount;
		}
		/**
		 * Get template positions
		 *
		 */
		function getPositions($template)
		{
			jimport('joomla.filesystem.folder');
			$result 		= array();
			$client 		=& JApplicationHelper::getClientInfo(0);

			if ($client === false)
			{
				return false;
			}

			$positions =  array();

			$path = $client->path.DS.'templates'.DS.$template;

			$xml =& JFactory::getXMLParser('Simple');
			if ($xml->loadFile($path.DS.'templateDetails.xml'))
			{
				$p =& $xml->document->getElementByPath('positions');
				if (is_a($p, 'JSimpleXMLElement') && count($p->children()))
				{
					foreach ($p->children() as $child)
					{
						if (!in_array($child->data(), $positions))
						{
							$positions[] = $child->data();

						}
					}

				}
			}

			$positions = array_unique($positions);
			if(count($positions))
			{
				foreach ($positions as $value)
				{
					$classModule 	= new stdClass();
					$classModule->value = $value;
					$classModule->text = $value;
					if(preg_match("/-m+$/", $value))
					{
						$result['mobile'] [] = $classModule;
					}
					else
					{
						$result['desktop'] [] = $classModule;
					}
				}
			}
			return $result;
		}
		/**
		 * render positions ComboBox
		 *
		 */
		function renderPositionComboBox($ID, $data, $elementName, $parameters = '')
		{
			array_unshift($data, JHTML::_('select.option', 'none', JText::_('NO_MAPPING'), 'value', 'text'));
			return JHTML::_('select.genericlist', $data, $elementName, $parameters, 'value', 'text', $ID);
		}
		/**
		 * Wrap first word inside a <span>
		 *
		 */
		function wrapFirstWord( $value )
		{
		 	$processed_string =  null;
		 	$explode_string = explode(' ', trim( $value ) );
		 	for ( $i=0; $i < count( $explode_string ); $i++ )
		 	{
		 		if( $i == 0 )
		 		{
		 			$processed_string .= '<span>'.$explode_string[$i].'</span>';
		 		}
		 		else
		 		{
		 			$processed_string .= ' '.$explode_string[$i];
		 		}
		 	}

		 	return $processed_string;
		 }

		/**
		 * Trim precedding slash
		 *
		 */
		function trimPreceddingSlash($string)
		{
			$string = trim($string);

			if (substr($string, 0, 1) == '\\' || substr($string, 0, 1) == '/') {
				$string = substr($string, 1);
			}

			return $string;
		}
		/**
		 * Trim ending slash
		 *
		 */
		function trimEndingSlash($string)
		{
			$string = trim($string);

			if (substr($string, -1) == '\\' || substr($string, -1) == '/') {
				$string = substr($string, 0, -1);
			}

			return $string;
		}
		/**
		 * Trim both ending slash
		 *
		 */
		function trimSlash($string)
		{
			$string = trim($string);

			$string = $this->trimPreceddingSlash($string);
			$string = $this->trimEndingSlash($string);

			return $string;
		}
		/**
		 * Strip extra space
		 *
		 */
		function StripExtraSpace($s)
		{
			$newstr = "";
			for($i = 0; $i < strlen($s); $i++)
			{
				$newstr = $newstr.substr($s, $i, 1);
				if(substr($s, $i, 1) == ' ')
				while(substr($s, $i + 1, 1) == ' ')
				$i++;
			}
			return $newstr;
		}
		/**
		 * Get mobile device
		 *
		 */
		function getMobileDevice()
		{
			$user_agent = $_SERVER['HTTP_USER_AGENT'];

			$mobileDeviceName = null;
			switch( true )
			{
				case ( preg_match( '/ipod/i', $user_agent ) || preg_match( '/iphone/i', $user_agent ) ):
					$mobileDeviceName = 'iphone';
				break;
				case ( preg_match( '/ipad/i', $user_agent ) ):
					$mobileDeviceName = 'ipad';
				break;
				case ( preg_match( '/android/i', $user_agent ) ):
					$mobileDeviceName = 'android';
				break;
				case ( preg_match( '/opera mini/i', $user_agent ) ):
					$mobileDeviceName = 'opera';
				break;
				case ( preg_match( '/blackberry/i', $user_agent ) ):
					$mobileDeviceName = 'blackberry';
				break;
				case ( preg_match( '/(pre\/|palm os|palm|hiptop|avantgo|plucker|xiino|blazer|elaine)/i', $user_agent ) ):
					$mobileDeviceName = 'palm';
				break;
				case ( preg_match( '/(windows ce; ppc;|windows mobile;|windows ce; smartphone;|windows ce; iemobile|windows phone)/i', $user_agent ) ):
					$mobileDeviceName = 'windows';
				break;
			}
			return $mobileDeviceName;
		}
		/**
		 * Replace breadcrumbs
		 *
		 */
		function replaceBreadcrumb($string)
		{
			global $jsn_richmenu_separator;
			if(isset($jsn_richmenu_separator) && $jsn_richmenu_separator !='')
			{
				$string = $this->splitSeparatorString($jsn_richmenu_separator, $string);
			}
			preg_match_all("/(\(icon-[a-zA-Z0-9_-]+\))/i", $string, $matches, PREG_PATTERN_ORDER);
			if($matches != false && count($matches[0]))
			{
				$string = $this->splitIconString($matches[0][0], $string);
			}
			return trim($string);
		}
		/**
		 * Split string contain separator
		 *
		 */
		function splitSeparatorString($delimiter, $string)
		{
			$position = strpos($string, $delimiter);
			if($position !== false)
			{
				$string = substr($string, 0, $position);
			}
			return trim($string);
		}
		/**
		 * Split string contain icon
		 *
		 */
		function splitIconString($delimiter, $string)
		{
			$position = strpos($string, $delimiter);
			if($position !== false)
			{
				$subStringLast 	 = substr($string, $position + JString::strlen($delimiter));
				$subStringFirst  = substr($string, 0, $position);
				$string 		 = $subStringFirst.$subStringLast;
				$string 		 = $this->StripExtraSpace($string);
			}
			return trim($string);
		}
		/**
		 * Encode object data to JSON data
		 *
		 */
		function encodeJSON($dataObj)
		{
			if (!function_exists('json_encode'))
			{
				if(!class_exists('Services_JSON'))
				{
					require_once 'json.php';
				}
			    $json = new Services_JSON;
			    return $json->encode($dataObj);
			}
			else
			{
				return json_encode($dataObj);
			}
		}
		/**
		 * Decode JSON string to object data
		 *
		 */
		function decodeJSON($stringJSON)
		{
			if (!function_exists('json_decode'))
			{
				if(!class_exists('Services_JSON'))
				{
					require_once 'json.php';
				}
			    $json = new Services_JSON;
			    return $json->decode($stringJSON);
			}
			else
			{
				return json_decode($stringJSON);
			}
		}
		/**
		 * Check folder is writable or not.
		 *
		 */
		function checkFolderWritable($path)
		{
			if (!is_writable($path)) {
				return false;
			}
			return true;
		}
		/**
		 * Clean up cache folder.
		 *
		 */
		function cleanupCacheFolder($template_name = '', $css_js_compression = 0, $cache_folder_path)
		{
			$cache_folder_path = str_replace('/', DS, $cache_folder_path);

			if( $css_js_compression !=  1 && $css_js_compression != 2 ) {
				if( $handle = opendir($cache_folder_path) ) {
					while (false !== ($file = readdir($handle))) {
						$pattern = '/^'.$template_name.'_css/';
						if( preg_match($pattern, $file) > 0 ) {
						    @unlink($cache_folder_path.'/'.$file);
						}
				    }
				}
			}

			if( $css_js_compression !=  1 && $css_js_compression != 3 ) {
				if( $handle = opendir($cache_folder_path) ) {
					while (false !== ($file = readdir($handle))) {
						$pattern = '/^'.$template_name.'_js/';
						if (preg_match($pattern, $file) > 0) {
						    @unlink($cache_folder_path.'/'.$file);
						}
				    }
				}
			}
		}
		/**
		 * Get Mootools version
		 *
		 */
		function getMootoolVersion()
		{
		    $matches	 = array();
			$application =& JFactory::getApplication();
			$doc		 =& JFactory::getDocument();
			$generator	 = $doc->getGenerator();
			preg_match ("/^nooku/i", $generator, $matches);
			if (count($matches))
			{
				return '1.2';
			}
			return substr(trim($application->get('MooToolsVersion', '1.11')), 0, 3);
		}
		/**
		 * Get article tools like pdf, email, print
		 *
		 */
		function articleTools($type = 'email', $article, $params, $access, $attribs = array())
		{
			if($type == 'pdf') {
				$url  = 'index.php?view=article';
				$url .=  @$article->catslug ? '&catid='.$article->catslug : '';
				$url .= '&id='.$article->slug.'&format=pdf';

				$status = 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no';

				// checks template image directory for image, if non found default are loaded
				$attribs['class'] = 'no-icon';
				if ($params->get('show_icons')) {
					$attribs['class'] = 'jsn-article-pdf-button';
					$text = '&nbsp;';
				} else {
					$text = JText::_('PDF').'&nbsp;';
				}

				$attribs['title']	= JText::_( 'PDF' );
				$attribs['onclick'] = "window.open(this.href,'win2','".$status."'); return false;";
				$attribs['rel']     = 'nofollow';

				return JHTML::_('link', JRoute::_($url), $text, $attribs);
			}
			if ($type == 'email') {
				require_once JPATH_SITE.'/components/com_content/helpers/route.php';
				$uri	=& JURI::getInstance();
				$base	= $uri->toString( array('scheme', 'host', 'port'));
				$link	= $base.JRoute::_( ContentHelperRoute::getArticleRoute($article->slug, $article->catslug, $article->sectionid) , false );
				$url	= 'index.php?option=com_mailto&tmpl=component&link='.base64_encode( $link );

				$status = 'width=400,height=350,menubar=yes,resizable=yes';

				$attribs['class'] = 'no-icon';
				if ($params->get('show_icons')) 	{
					$attribs['class'] = 'jsn-article-email-button';
					$text = '&nbsp;';
				} else {
					$text = '&nbsp;'.JText::_('Email');
				}

				$attribs['title']	= JText::_( 'Email' );
				$attribs['onclick'] = "window.open(this.href,'win2','".$status."'); return false;";

				$output = JHTML::_('link', JRoute::_($url), $text, $attribs);
				return $output;
			}
			if($type == 'print_popup') {
				$url  = 'index.php?view=article';
				$url .=  @$article->catslug ? '&catid='.$article->catslug : '';
				$url .= '&id='.$article->slug.'&tmpl=component&print=1&layout=default&page='.@ $request->limitstart;

				$status = 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no';

				// checks template image directory for image, if non found default are loaded
				$attribs['class'] = 'no-icon';
				if ( $params->get( 'show_icons' ) ) {
					$attribs['class'] = 'jsn-article-print-button';
					$text = '&nbsp;';
				} else {
					$text = JText::_('Print');
				}

				$attribs['title']	= JText::_( 'Print' );
				$attribs['onclick'] = "window.open(this.href,'win2','".$status."'); return false;";
				$attribs['rel']     = 'nofollow';

				return JHTML::_('link', JRoute::_($url), $text, $attribs);
			}
			if($type = 'print_screen') {
				$attribs['class'] = 'no-icon';
				if ( $params->get( 'show_icons' ) ) {
					$attribs['class'] = 'jsn-article-print-button';
					$text = '&nbsp;';
				} else {
					$text = JText::_('Print');
				}
				return '<a class="'.$attribs['class'].'" href="#" onclick="window.print();return false;">'.$text.'</a>';

			}
		}

		function getAllFileInHeadSection(&$header_stuff, $type, &$ref_data)
		{
			$uri = JURI::base(true);

			if ($type == 'css')
			{
				$datas 	=& $header_stuff['styleSheets'];
				$file_extensions = '.css';
			}

			if ($type == 'js')
			{
				$datas =& $header_stuff['scripts'];
				$file_extensions = '.js';
			}

			foreach ($datas as $key=>$script)
			{
				$cleaned_url = $this->clarifyUrl($key);
				if ($cleaned_url)
				{
					if (preg_match('#\.'.$type.'$#', $cleaned_url))
					{
						$file_name 		= basename($cleaned_url);
						$file_rel_path  = dirname($cleaned_url);
						$file_abs_path	= JPATH_ROOT.DS.str_replace("/", DS, $file_rel_path);
						$ref_data[$uri.'/'.$file_rel_path.'/'.$file_name]['file_abs_path'] 	= $file_abs_path;
						$ref_data[$uri.'/'.$file_rel_path.'/'.$file_name]['file_name']		= $file_name;
						// Remove them from HEAD
						unset($datas[$key]);
					}
				}
			}

		}

		function arrangeFileInHeadSection(&$header_stuff, $firstOrdering)
		{

			// remove modal.js, core.js in HeaderData to prevent double load
			unset($header_stuff['scripts'][JURI::root(true).'/media/system/js/modal.js']);
			unset($header_stuff['scripts'][JURI::root(true).'/media/system/js/core.js']);

			// arrange file
			$datas  =& $header_stuff['scripts'];
			$count	= count($datas);
			if ($count)
			{
				$first 	= array();
				foreach ($datas as $key => $value)
				{
					if (in_array($key, $firstOrdering)) {
						$first[$key] = $value;
						unset($datas[$key]);
					}
				}
				$datas = $first + $datas;
			}
		}
		/**
		 * Get browser specific information
		 *
		 */
		function getBrowserInfo($agent = null)
		{
			$browser = array("browser"=>'', "version"=>'');
			$known = array("firefox", "msie", "opera", "chrome", "safari",
						"mozilla", "seamonkey", "konqueror", "netscape",
			            "gecko", "navigator", "mosaic", "lynx", "amaya",
			            "omniweb", "avant", "camino", "flock", "aol");
			$agent = strtolower($agent ? $agent : $_SERVER['HTTP_USER_AGENT']);
			foreach($known as $value)
			{
				if (preg_match("#($value)[/ ]?([0-9.]*)#", $agent, $matches))
				{
					$browser['browser'] = $matches[1];
					$browser['version'] = $matches[2];
					break;
				}
			}
			return $browser;
		}
		/**
		 * Get current URL
		 *
		 */
		function getCurrentUrl() {
			$uri =& JURI::getInstance();
			return $uri->toString();
		}
		/**
		 * check System Cache - Plugin
		 *
		 */
		function checkSystemCache() {
			$db = JFactory::getDbo();
			$query = "SELECT published " .
					" FROM #__plugins" .
					" WHERE name='System - Cache'"
			;
			$db->setQuery($query);
			return (bool) $db->loadResult();
		}

		/**
		 * check K2 installed or not
		 *
		 */
		function checkK2()
		{
			$db 	= JFactory::getDbo();
			if ($this->getJoomlaVersion() == '15') {
				$query = "SELECT id " .
					" FROM #__components" .
					" WHERE `option` = 'com_k2'" .
					" AND admin_menu_alt = 'COM_K2'" .
					" AND enabled = 1"
				;
			} else {
				$query	= $db->getQuery(true);
				$query->select('extension_id');
				$query->from('`#__extensions`');
				$query->where("enabled = 1");
				$query->where("type = 'component'");
				$query->where("element = 'com_k2'");
			}
			$db->setQuery($query);
			return (bool) $db->loadResult();
		}

		function getJoomlaVersion($glue = false)
		{
			$objVersion = new JVersion();
			$version	= (float) $objVersion->RELEASE;

			if ($version <= 1.5)
			{
				return ($glue)?'1.5':'15';
			}
			elseif ($version >= 1.6 && $version <= 1.7)
			{
				return ($glue)?'2.5':'25';
			}
			else
			{
				return ($glue)?$objVersion->RELEASE:str_replace('.', '', $objVersion->RELEASE);
			}
		}

		function cURLCheckFunctions()
		{
		  if(!function_exists("curl_init") && !function_exists("curl_setopt") && !function_exists("curl_exec") && !function_exists("curl_close")) return false;
		  return true;
		}

		function fOPENCheck()
		{
			return (boolean) ini_get('allow_url_fopen');
		}

		function fsocketopenCheck()
		{
			if (!function_exists('fsockopen')) return false;
			return true;
		}

		function compareVersion($version1 , $version2)
		{
			//-1: if the first version < the second
			//0: if they are equal
			//1: if the first version > the second
			return version_compare($version1, $version2);
		}

		function getLatestVersion($template_name)
		{
			require_once('jsn_httpsocket.php');
			$template = $this->getTemplateDetails();
			$exploded_template_name	= explode('_', JString::strtolower($template->name));
			$identified_name		= 'tpl_'.@$exploded_template_name[1];
			$edition				= JString::strtolower($template->edition);
			if ($template->edition != '' && strtolower($template->edition) != 'free')
			{
				$edition = 'pro '.strtolower($template->edition);
			}
			else
			{
				$edition = 'free';
			}
			$url 					= JSN_TEMPLATE_INFO_URL.'&identified_name='.urlencode($identified_name).'&edition='.urlencode($edition);
			$obj_http_request 		= new JSNHTTPSocket($url, null, null, 'get');
			$result    		  		= $obj_http_request->socketDownload();

			if($result == false)
			{
				return '';
			}
			else
			{
				$stringDecode = $this->decodeJSON($result);
				if (isset($stringDecode->version))
				{
					$version = $stringDecode->version;
				}
				else
				{
					$version = '';
				}
				return $version;
			}
		}
		
		function clarifyUrl($url)
	    {
	    	$url = preg_replace('/[?\#]+.*$/', '', $url);

	        if (preg_match('/^https?\:/', $url))
	        {
	            if (!preg_match('#^'.preg_quote(JURI::root()).'#', $url))
	            {
	                return false;
	            }
	            $url = str_replace(JURI::root(), '', $url);
	        }

	        if (preg_match('/^\//', $url) && JURI::root(true))
	        {
	        	if (!preg_match('#^'.preg_quote(JURI::root(true)).'#', $url))
	            {
	                return false;
	            }
	            $url = preg_replace('#^'.preg_quote(JURI::root(true)).'#', '', $url);
	        }

	        $url = preg_replace('/^\//', '', preg_replace('#[/\\\\]+#', '/', $url));
	        return $url;
	    }

	    function checkProEditionExist($templateName, $pro = false)
	    {
	    	if ($pro === true)
	    	{
	    		$templateName = str_replace('free', 'pro', $templateName);
	    	}

    		/* Check whether the template folder exists */
    		$templateFolderPath = JPATH_ROOT.DS.'templates'.DS.$templateName;
    		jimport('joomla.filesystem.folder');
    		if (JFolder::exists($templateFolderPath))
    		{
    			return true;
    		}

	    	return false;
	    }
	}
?>